/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUPAFI_PARAMFILIAL                                          */
/* Tabela : PARAMFILIAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 17/10/2006 - Disnei H. de Moura                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUPAFI_PARAMFILIAL
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMFILIAL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPAFI  := SYSDATE;
      IF :NEW.IDUTMODPRODFIL IS NOT NULL THEN
         UPDATE PARAVEND
            SET IDUTILMODPROD = :NEW.IDUTMODPRODFIL
          WHERE CDFILIAL = :NEW.CDFILIAL;
      END IF;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0 )       <> NVL(:NEW.CDFILIAL,0))        OR
         (NVL(:OLD.IDCTRLESTQ,0 )     <> NVL(:NEW.IDCTRLESTQ,0))      OR
         (NVL(:OLD.CDALMOXARIFE,0 )   <> NVL(:NEW.CDALMOXARIFE,0))    OR
         (NVL(:OLD.CDLOCALESTOQ,0 )   <> NVL(:NEW.CDLOCALESTOQ,0))    OR
         (NVL(:OLD.DSNUMELOTE,0 )     <> NVL(:NEW.DSNUMELOTE,0))      OR
         (NVL(:OLD.IDUTILALMOX,0 )    <> NVL(:NEW.IDUTILALMOX,0))     OR
         (NVL(:OLD.IDUTILLCESTQ,0 )   <> NVL(:NEW.IDUTILLCESTQ,0))    OR
         (NVL(:OLD.IDUTILLOTE,0 )     <> NVL(:NEW.IDUTILLOTE,0))      OR
         (NVL(:OLD.IDENTRSEQLOTE,0)   <> NVL(:NEW.IDENTRSEQLOTE,0))   OR
         (NVL(:OLD.IDENTRAUTLOTE,0)   <> NVL(:NEW.IDENTRAUTLOTE,0))   OR
         (NVL(:OLD.NRIPADDRFILI,0)    <> NVL(:NEW.NRIPADDRFILI,0))    OR 
         (NVL(:OLD.IDUTMODPRODFIL,0)  <> NVL(:NEW.IDUTMODPRODFIL,0))  OR 
         (NVL(:OLD.IDUTCTRLFISENTR,0) <> NVL(:NEW.IDUTCTRLFISENTR,0)) OR
         (NVL(:OLD.IDUTCTRLFISSAID,0) <> NVL(:NEW.IDUTCTRLFISSAID,0)) OR
         (NVL(:OLD.DSPERS,0)          <> NVL(:NEW.DSPERS,0))          OR  
         (NVL(:OLD.DSOPERNFSERV,0)    <> NVL(:NEW.DSOPERNFSERV,0))    OR  
         (NVL(:OLD.DTPROCESSA,TO_DATE('31/12/1899','DD/MM/YYYY'))     <>
          NVL(:NEW.DTPROCESSA,TO_DATE('31/12/1899','DD/MM/YYYY')))    THEN

         :NEW.DTULTATUPAFI  := SYSDATE;
         IF :NEW.IDUTMODPRODFIL IS NOT NULL THEN
            UPDATE PARAVEND
               SET IDUTILMODPROD = :NEW.IDUTMODPRODFIL
             WHERE CDFILIAL = :NEW.CDFILIAL;
         END IF;

      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARAMFILIAL', '','CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PARAMFILIAL MODIFY DTULTATUPAFI DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATUPAFI_PARAMFILIAL','0.00.000'); END;
/

